# google-docs-ti
Reads and writes Google Docs documents.

This Python package is automatically generated by the [OpenAPI Generator](https://openapi-generator.tech) project:

- API version: v1
- Package version: 0.0.1
- Generator version: 7.11.0
- Build package: org.openapitools.codegen.languages.PythonClientCodegen
For more information, please visit [https://google.com](https://google.com)

## Requirements.

Python 3.8+

## Installation & Usage
### pip install

If the python package is hosted on a repository, you can install directly using:

```sh
pip install git+https://github.com/GIT_USER_ID/GIT_REPO_ID.git
```
(you may need to run `pip` with root permission: `sudo pip install git+https://github.com/GIT_USER_ID/GIT_REPO_ID.git`)

Then import the package:
```python
import google_docs_ti
```

### Setuptools

Install via [Setuptools](http://pypi.python.org/pypi/setuptools).

```sh
python setup.py install --user
```
(or `sudo python setup.py install` to install the package for all users)

Then import the package:
```python
import google_docs_ti
```

### Tests

Execute `pytest` to run the tests.

## Getting Started

Please follow the [installation procedure](#installation--usage) and then run the following:

```python

import google_docs_ti
from google_docs_ti.rest import ApiException
from pprint import pprint

# Defining the host is optional and defaults to https://docs.googleapis.com
# See configuration.py for a list of all supported configuration parameters.
configuration = google_docs_ti.Configuration(
    host = "https://docs.googleapis.com"
)

# The client must configure the authentication and authorization parameters
# in accordance with the API server security policy.
# Examples for each auth method are provided below, use the example that
# satisfies your auth use case.

configuration.access_token = os.environ["ACCESS_TOKEN"]

configuration.access_token = os.environ["ACCESS_TOKEN"]


# Enter a context with an instance of the API client
with google_docs_ti.ApiClient(configuration) as api_client:
    # Create an instance of the API class
    api_instance = google_docs_ti.DocumentsApi(api_client)
    document_id = 'document_id_example' # str | The ID of the document to update.
    access_token = 'access_token_example' # str | OAuth access token. (optional)
    alt = json # str | Data format for response. (optional) (default to json)
    param_callback = 'param_callback_example' # str | JSONP (optional)
    fields = 'fields_example' # str | Selector specifying which fields to include in a partial response. (optional)
    key = 'key_example' # str | API key. Your API key identifies your project and provides you with API access, quota, and reports. Required unless you provide an OAuth 2.0 token. (optional)
    oauth_token = 'oauth_token_example' # str | OAuth 2.0 token for the current user. (optional)
    pretty_print = True # bool | Returns response with indentations and line breaks. (optional) (default to True)
    quota_user = 'quota_user_example' # str | Available to use for quota purposes for server-side applications. Can be any arbitrary string assigned to a user, but should not exceed 40 characters. (optional)
    upload_protocol = 'upload_protocol_example' # str | Upload protocol for media (e.g. \"raw\", \"multipart\"). (optional)
    upload_type = 'upload_type_example' # str | Legacy upload protocol for media (e.g. \"media\", \"multipart\"). (optional)
    xgafv = 'xgafv_example' # str | V1 error format. (optional)
    batch_update_document_request = google_docs_ti.BatchUpdateDocumentRequest() # BatchUpdateDocumentRequest |  (optional)

    try:
        api_response = api_instance.docs_documents_batch_update(document_id, access_token=access_token, alt=alt, param_callback=param_callback, fields=fields, key=key, oauth_token=oauth_token, pretty_print=pretty_print, quota_user=quota_user, upload_protocol=upload_protocol, upload_type=upload_type, xgafv=xgafv, batch_update_document_request=batch_update_document_request)
        print("The response of DocumentsApi->docs_documents_batch_update:\n")
        pprint(api_response)
    except ApiException as e:
        print("Exception when calling DocumentsApi->docs_documents_batch_update: %s\n" % e)

```

## Documentation for API Endpoints

All URIs are relative to *https://docs.googleapis.com*

Class | Method | HTTP request | Description
------------ | ------------- | ------------- | -------------
*DocumentsApi* | [**docs_documents_batch_update**](docs/DocumentsApi.md#docs_documents_batch_update) | **POST** /v1/documents/{documentId}:batchUpdate | 
*DocumentsApi* | [**docs_documents_create**](docs/DocumentsApi.md#docs_documents_create) | **POST** /v1/documents | 
*DocumentsApi* | [**docs_documents_get**](docs/DocumentsApi.md#docs_documents_get) | **GET** /v1/documents/{documentId} | 


## Documentation For Models

 - [AutoText](docs/AutoText.md)
 - [Background](docs/Background.md)
 - [BackgroundSuggestionState](docs/BackgroundSuggestionState.md)
 - [BatchUpdateDocumentRequest](docs/BatchUpdateDocumentRequest.md)
 - [BatchUpdateDocumentResponse](docs/BatchUpdateDocumentResponse.md)
 - [Body](docs/Body.md)
 - [BookmarkLink](docs/BookmarkLink.md)
 - [Bullet](docs/Bullet.md)
 - [BulletSuggestionState](docs/BulletSuggestionState.md)
 - [Color](docs/Color.md)
 - [ColumnBreak](docs/ColumnBreak.md)
 - [CreateFooterRequest](docs/CreateFooterRequest.md)
 - [CreateFooterResponse](docs/CreateFooterResponse.md)
 - [CreateFootnoteRequest](docs/CreateFootnoteRequest.md)
 - [CreateFootnoteResponse](docs/CreateFootnoteResponse.md)
 - [CreateHeaderRequest](docs/CreateHeaderRequest.md)
 - [CreateHeaderResponse](docs/CreateHeaderResponse.md)
 - [CreateNamedRangeRequest](docs/CreateNamedRangeRequest.md)
 - [CreateNamedRangeResponse](docs/CreateNamedRangeResponse.md)
 - [CreateParagraphBulletsRequest](docs/CreateParagraphBulletsRequest.md)
 - [CropProperties](docs/CropProperties.md)
 - [CropPropertiesSuggestionState](docs/CropPropertiesSuggestionState.md)
 - [DeleteContentRangeRequest](docs/DeleteContentRangeRequest.md)
 - [DeleteFooterRequest](docs/DeleteFooterRequest.md)
 - [DeleteHeaderRequest](docs/DeleteHeaderRequest.md)
 - [DeleteNamedRangeRequest](docs/DeleteNamedRangeRequest.md)
 - [DeleteParagraphBulletsRequest](docs/DeleteParagraphBulletsRequest.md)
 - [DeletePositionedObjectRequest](docs/DeletePositionedObjectRequest.md)
 - [DeleteTableColumnRequest](docs/DeleteTableColumnRequest.md)
 - [DeleteTableRowRequest](docs/DeleteTableRowRequest.md)
 - [Dimension](docs/Dimension.md)
 - [Document](docs/Document.md)
 - [DocumentStyle](docs/DocumentStyle.md)
 - [DocumentStyleSuggestionState](docs/DocumentStyleSuggestionState.md)
 - [DocumentTab](docs/DocumentTab.md)
 - [EmbeddedObject](docs/EmbeddedObject.md)
 - [EmbeddedObjectBorder](docs/EmbeddedObjectBorder.md)
 - [EmbeddedObjectBorderSuggestionState](docs/EmbeddedObjectBorderSuggestionState.md)
 - [EmbeddedObjectSuggestionState](docs/EmbeddedObjectSuggestionState.md)
 - [EndOfSegmentLocation](docs/EndOfSegmentLocation.md)
 - [Equation](docs/Equation.md)
 - [Footer](docs/Footer.md)
 - [Footnote](docs/Footnote.md)
 - [FootnoteReference](docs/FootnoteReference.md)
 - [Header](docs/Header.md)
 - [HeadingLink](docs/HeadingLink.md)
 - [HorizontalRule](docs/HorizontalRule.md)
 - [ImageProperties](docs/ImageProperties.md)
 - [ImagePropertiesSuggestionState](docs/ImagePropertiesSuggestionState.md)
 - [InlineObject](docs/InlineObject.md)
 - [InlineObjectElement](docs/InlineObjectElement.md)
 - [InlineObjectProperties](docs/InlineObjectProperties.md)
 - [InlineObjectPropertiesSuggestionState](docs/InlineObjectPropertiesSuggestionState.md)
 - [InsertInlineImageRequest](docs/InsertInlineImageRequest.md)
 - [InsertInlineImageResponse](docs/InsertInlineImageResponse.md)
 - [InsertInlineSheetsChartResponse](docs/InsertInlineSheetsChartResponse.md)
 - [InsertPageBreakRequest](docs/InsertPageBreakRequest.md)
 - [InsertSectionBreakRequest](docs/InsertSectionBreakRequest.md)
 - [InsertTableColumnRequest](docs/InsertTableColumnRequest.md)
 - [InsertTableRequest](docs/InsertTableRequest.md)
 - [InsertTableRowRequest](docs/InsertTableRowRequest.md)
 - [InsertTextRequest](docs/InsertTextRequest.md)
 - [Link](docs/Link.md)
 - [LinkedContentReference](docs/LinkedContentReference.md)
 - [LinkedContentReferenceSuggestionState](docs/LinkedContentReferenceSuggestionState.md)
 - [List](docs/List.md)
 - [ListProperties](docs/ListProperties.md)
 - [ListPropertiesSuggestionState](docs/ListPropertiesSuggestionState.md)
 - [Location](docs/Location.md)
 - [MergeTableCellsRequest](docs/MergeTableCellsRequest.md)
 - [NamedRange](docs/NamedRange.md)
 - [NamedRanges](docs/NamedRanges.md)
 - [NamedStyle](docs/NamedStyle.md)
 - [NamedStyleSuggestionState](docs/NamedStyleSuggestionState.md)
 - [NamedStyles](docs/NamedStyles.md)
 - [NamedStylesSuggestionState](docs/NamedStylesSuggestionState.md)
 - [NestingLevel](docs/NestingLevel.md)
 - [NestingLevelSuggestionState](docs/NestingLevelSuggestionState.md)
 - [ObjectReferences](docs/ObjectReferences.md)
 - [OptionalColor](docs/OptionalColor.md)
 - [PageBreak](docs/PageBreak.md)
 - [Paragraph](docs/Paragraph.md)
 - [ParagraphBorder](docs/ParagraphBorder.md)
 - [ParagraphElement](docs/ParagraphElement.md)
 - [ParagraphStyle](docs/ParagraphStyle.md)
 - [ParagraphStyleSuggestionState](docs/ParagraphStyleSuggestionState.md)
 - [Person](docs/Person.md)
 - [PersonProperties](docs/PersonProperties.md)
 - [PinTableHeaderRowsRequest](docs/PinTableHeaderRowsRequest.md)
 - [PositionedObject](docs/PositionedObject.md)
 - [PositionedObjectPositioning](docs/PositionedObjectPositioning.md)
 - [PositionedObjectPositioningSuggestionState](docs/PositionedObjectPositioningSuggestionState.md)
 - [PositionedObjectProperties](docs/PositionedObjectProperties.md)
 - [PositionedObjectPropertiesSuggestionState](docs/PositionedObjectPropertiesSuggestionState.md)
 - [Range](docs/Range.md)
 - [ReplaceAllTextRequest](docs/ReplaceAllTextRequest.md)
 - [ReplaceAllTextResponse](docs/ReplaceAllTextResponse.md)
 - [ReplaceImageRequest](docs/ReplaceImageRequest.md)
 - [ReplaceNamedRangeContentRequest](docs/ReplaceNamedRangeContentRequest.md)
 - [Request](docs/Request.md)
 - [Response](docs/Response.md)
 - [RgbColor](docs/RgbColor.md)
 - [RichLink](docs/RichLink.md)
 - [RichLinkProperties](docs/RichLinkProperties.md)
 - [SectionBreak](docs/SectionBreak.md)
 - [SectionColumnProperties](docs/SectionColumnProperties.md)
 - [SectionStyle](docs/SectionStyle.md)
 - [Shading](docs/Shading.md)
 - [ShadingSuggestionState](docs/ShadingSuggestionState.md)
 - [SheetsChartReference](docs/SheetsChartReference.md)
 - [SheetsChartReferenceSuggestionState](docs/SheetsChartReferenceSuggestionState.md)
 - [Size](docs/Size.md)
 - [SizeSuggestionState](docs/SizeSuggestionState.md)
 - [StructuralElement](docs/StructuralElement.md)
 - [SubstringMatchCriteria](docs/SubstringMatchCriteria.md)
 - [SuggestedBullet](docs/SuggestedBullet.md)
 - [SuggestedDocumentStyle](docs/SuggestedDocumentStyle.md)
 - [SuggestedInlineObjectProperties](docs/SuggestedInlineObjectProperties.md)
 - [SuggestedListProperties](docs/SuggestedListProperties.md)
 - [SuggestedNamedStyles](docs/SuggestedNamedStyles.md)
 - [SuggestedParagraphStyle](docs/SuggestedParagraphStyle.md)
 - [SuggestedPositionedObjectProperties](docs/SuggestedPositionedObjectProperties.md)
 - [SuggestedTableCellStyle](docs/SuggestedTableCellStyle.md)
 - [SuggestedTableRowStyle](docs/SuggestedTableRowStyle.md)
 - [SuggestedTextStyle](docs/SuggestedTextStyle.md)
 - [Tab](docs/Tab.md)
 - [TabProperties](docs/TabProperties.md)
 - [TabStop](docs/TabStop.md)
 - [Table](docs/Table.md)
 - [TableCell](docs/TableCell.md)
 - [TableCellBorder](docs/TableCellBorder.md)
 - [TableCellLocation](docs/TableCellLocation.md)
 - [TableCellStyle](docs/TableCellStyle.md)
 - [TableCellStyleSuggestionState](docs/TableCellStyleSuggestionState.md)
 - [TableColumnProperties](docs/TableColumnProperties.md)
 - [TableOfContents](docs/TableOfContents.md)
 - [TableRange](docs/TableRange.md)
 - [TableRow](docs/TableRow.md)
 - [TableRowStyle](docs/TableRowStyle.md)
 - [TableRowStyleSuggestionState](docs/TableRowStyleSuggestionState.md)
 - [TableStyle](docs/TableStyle.md)
 - [TabsCriteria](docs/TabsCriteria.md)
 - [TextRun](docs/TextRun.md)
 - [TextStyle](docs/TextStyle.md)
 - [TextStyleSuggestionState](docs/TextStyleSuggestionState.md)
 - [UnmergeTableCellsRequest](docs/UnmergeTableCellsRequest.md)
 - [UpdateDocumentStyleRequest](docs/UpdateDocumentStyleRequest.md)
 - [UpdateParagraphStyleRequest](docs/UpdateParagraphStyleRequest.md)
 - [UpdateSectionStyleRequest](docs/UpdateSectionStyleRequest.md)
 - [UpdateTableCellStyleRequest](docs/UpdateTableCellStyleRequest.md)
 - [UpdateTableColumnPropertiesRequest](docs/UpdateTableColumnPropertiesRequest.md)
 - [UpdateTableRowStyleRequest](docs/UpdateTableRowStyleRequest.md)
 - [UpdateTextStyleRequest](docs/UpdateTextStyleRequest.md)
 - [WeightedFontFamily](docs/WeightedFontFamily.md)
 - [WriteControl](docs/WriteControl.md)


<a id="documentation-for-authorization"></a>
## Documentation For Authorization


Authentication schemes defined for the API:
<a id="Oauth2"></a>
### Oauth2

- **Type**: OAuth
- **Flow**: implicit
- **Authorization URL**: https://accounts.google.com/o/oauth2/auth
- **Scopes**: 
 - **https://www.googleapis.com/auth/documents**: See, edit, create, and delete all your Google Docs documents
 - **https://www.googleapis.com/auth/documents.readonly**: See all your Google Docs documents
 - **https://www.googleapis.com/auth/drive**: See, edit, create, and delete all of your Google Drive files
 - **https://www.googleapis.com/auth/drive.file**: See, edit, create, and delete only the specific Google Drive files you use with this app
 - **https://www.googleapis.com/auth/drive.readonly**: See and download all your Google Drive files

<a id="Oauth2c"></a>
### Oauth2c

- **Type**: OAuth
- **Flow**: accessCode
- **Authorization URL**: https://accounts.google.com/o/oauth2/auth
- **Scopes**: 
 - **https://www.googleapis.com/auth/documents**: See, edit, create, and delete all your Google Docs documents
 - **https://www.googleapis.com/auth/documents.readonly**: See all your Google Docs documents
 - **https://www.googleapis.com/auth/drive**: See, edit, create, and delete all of your Google Drive files
 - **https://www.googleapis.com/auth/drive.file**: See, edit, create, and delete only the specific Google Drive files you use with this app
 - **https://www.googleapis.com/auth/drive.readonly**: See and download all your Google Drive files


## Author




